###################################
#  Code to replicate the tests of RE on annual earnings (Table 2)
###################################

rm(list=ls())
## load packages
library(RationalExp)
library(snowfall)
library(foreign)
require(pracma)
require(MESS)
require(sfsmisc)
library(splines)
library(fitdistrplus)
library(truncdist)
library(quantmod)      
library(ggplot2)
library(reshape2)
library(matlab)
library(xtable)

path="TO COMPLETE WITH THE PATH OF THE DATA FOLDER"

## define output arrays
outt0 <- NULL
out_direct0 <-NULL
out_direct = NULL
data_testsW <- NULL
ql <- 0.00
qu <- 0.95

## select the subpopulation
for(index in c(1,4:13)){

  #######################################################################################
  ##################  load all datasets      ###############
  
  load( file=paste0(path,"data/sub_data_real.Rdata"))
  load( file=paste0(path,"data/sub_data_exp.Rdata"))
  load( file=paste0(path,"data/data_1_sel.Rdata"))
  load( file=paste0(path,"data/data_2_sel.Rdata"))
  load( file=paste0(path,"data/sub_data.Rdata"))
     
      ### all
      if(index ==1){
        ### NADA
        
      }
      
      ### self employed
      if(index ==2){
        
        indic <- data_1_sel$self==1
        data_1_sel <- data_1_sel[indic,]
      }
      ### Wage earners
      if(index ==3){
        indic <- data_1_sel$self==1
        data_1_sel <- data_1_sel[!indic,]
      }
      
      ### women
      if(index ==4){
        indic <- data_1_sel$sex==0
        data_1_sel <- data_1_sel[indic,]
      }
      ### men
      if(index ==5){
        indic <- data_1_sel$sex==0
        data_1_sel <- data_1_sel[!indic,]
      }
      ### white
      if(index ==6){
        indic <- data_1_sel$white==1
        data_1_sel <- data_1_sel[indic,]
      }  
      
      ### others
      if(index ==7){
        indic <- data_1_sel$white==1
        data_1_sel <- data_1_sel[!indic,]
      }  
      
      ### college
      if(index ==8){
        indic <- data_1_sel$HS==1
        data_1_sel <- data_1_sel[indic,]
      }  
      
      ### no coll
      if(index ==9){
        indic <- data_1_sel$HS==1
        data_1_sel <- data_1_sel[!indic,]
      }    
      
     
     
      if(index ==10){
        indic <- data_1_sel$NUM_CAT==2
        data_1_sel <- data_1_sel[indic,]
      }
      if(index ==11){
        indic <- data_1_sel$NUM_CAT==2
        data_1_sel <- data_1_sel[!indic,]
      } 
      
      
      if(index ==12){
        indic <- data_1_sel$exp<=2
        data_1_sel <- data_1_sel[indic,]
      } 
      
      if(index ==13){
        indic <- data_1_sel$exp >2
        data_1_sel <- data_1_sel[indic,]
      }
      
      indic <- data_2_sel$work==0 & data_2_sel$unemp==0  
      indic1 <- indic
      indic1[is.na(indic)] <- FALSE
      data_2_sel <- data_2_sel[!indic1,]
      if(index ==1){
        ### NADA
        
      }
      
      ### Wage earners
      if(index ==2){
        
        indic <- data_2_sel$self==1
        data_2_sel <- data_2_sel[indic,]
      }
      ### self employed
      if(index ==3){
        indic <- data_2_sel$self==1
        data_2_sel <- data_2_sel[!indic,]
      }
      
      ### women
      if(index ==4){
        indic <- data_2_sel$sex==0
        data_2_sel <- data_2_sel[indic,]
      }
      ### men
      if(index ==5){
        indic <- data_2_sel$sex==0
        data_2_sel <- data_2_sel[!indic,]
      }
      ### white
      if(index ==6){
        indic <- data_2_sel$white==1
        data_2_sel <- data_2_sel[indic,]
      }  
      
      ### others
      if(index ==7){
        indic <- data_2_sel$white==1
        data_2_sel <- data_2_sel[!indic,]
      }  
      
      ### college
      if(index ==8){
        indic <- data_2_sel$HS==1
        data_2_sel <- data_2_sel[indic,]
      }  
      
      ### no coll
      if(index ==9){
        indic <- data_2_sel$HS==1
        data_2_sel <- data_2_sel[!indic,]
      }    
      
      if(index ==10){
        indic <- data_2_sel$NUM_CAT==2
        data_2_sel <- data_2_sel[indic,]
      }
      if(index ==11){
        indic <- data_2_sel$NUM_CAT==2
        data_2_sel <- data_2_sel[!indic,]
      } 
      
     
      if(index ==12){
        indic <- data_2_sel$exp<=2
        data_2_sel <- data_2_sel[indic,]
      } 
      
      if(index ==13){
        indic <- data_2_sel$exp >2
        data_2_sel<- data_2_sel[indic,]
      }
      ######################## Winsorisation ########################
      
      y_set <- data_1_sel
      sel <- data_1_sel$oo2e2 <quantile(data_1_sel$oo2e2, qu) & data_1_sel$oo2e2 >quantile(data_1_sel$oo2e2, ql)
      y_set <- y_set[sel ,]
      Qu = quantile( y_set$oo2e2, 1)
      Ql = quantile( y_set$oo2e2, 0)
      y_set_0 <- data_1_sel
      y_set_0[data_1_sel$oo2e2 >=quantile(data_1_sel$oo2e2, qu)  ,"oo2e2"] <-  Qu
      data_1_sel<- y_set_0
      
      y_set <- data_2_sel
      sel <- data_2_sel$past_inc <quantile(data_2_sel$past_inc, qu) & data_2_sel$past_inc >quantile(data_2_sel$past_inc, ql)
      y_set <- y_set[sel ,]
      Ql = quantile( y_set$past_inc , 0)
      Qu = quantile( y_set$past_inc , 1)
      y_set_0 <- data_2_sel
      y_set_0[data_2_sel$past_inc >=quantile(data_2_sel$past_inc, qu)  ,"past_inc"] <-  Qu
      data_2_sel<- y_set_0
      

      ##################################################################################################################################### 
      ##########     Full RE test. 
      ##########
      ##########
      ##########
      ############################################################################

      
      data_st <- data_2_sel 
      data_psi <-data_1_sel 
      
      colnames(data_st)[3] <- "y"
      colnames(data_psi)[3] <- "psi"
      colnames(data_st)[5] <- "wt"
      colnames(data_psi)[4] <- "wt"
      data_st$X <- data_st$age
      data_psi$X <- data_psi$age

      ref <- quantile(data_st$X, seq(1,100,10)/100)
      ref<-c(0,ref,Inf)

      #### to manage the weights
      dates_2 <- sort(unique(data_st$date))
      dates <-sort(unique(data_psi$date))
      LIM = 2
     
      data_testsW_save <- NULL
      sel_age =0
      R2_s =NULL
      wy_glob <- NULL
      n_glob <- NULL
      n_glob_y <- NULL
      wp_glob <-NULL
      psi_glob <- NULL 
      y_glob <- NULL
      age_glob <- NULL
      agep_glob <- NULL
      # up<- length(years)
      
      # plot_hist(9)
      for(i in 1:LIM){
        sub_1 <- subset(data_st, date==dates_2[which.min(abs(dates_2-dates[i]))+1])
        y <- sub_1$y #- inflation[i] 
        wt_y<- sub_1$wt/sum(sub_1$wt)
        age <- sub_1$age
        
        sub_2 <- subset(data_psi, date==dates[i])
        psi <- sub_2$psi
        wt<- sub_2$wt
        agep <- sub_2$age
        

        psi_glob <-  c(psi_glob ,psi)
        wy_glob <-c(wy_glob,wt_y)
        wp_glob <-c(wp_glob,wt)
        y_glob <-c(y_glob,y)
        n_glob <- c( n_glob, length(psi))
        n_glob_y <- c( n_glob_y, length(y))
        age_glob <-c( age_glob,age)
        agep_glob <-c(agep_glob,agep)
      }
      
      y <- y_glob
      psi <- psi_glob
      
      #### managing weights
      factor<- NULL
      factor_y <- NULL
      proportions <- n_glob/length( psi_glob)
      proportions_y <- n_glob_y/length( y_glob)
      for (j in 1:LIM){
        factor <- c(factor, matrix(proportions[j],1,n_glob[j]))
        factor_y <- c(factor_y, matrix(proportions_y[j],1,n_glob_y[j]))
      }
      length(factor)
      length(wt)
      
      length(wy_glob)
      wt_y <-wy_glob*factor_y
      wt <-wp_glob* factor 

      total <- cbind(y,wt_y, age_glob)
      total <- na.omit(total)
      
      ####
      y <- total[,1]
      wt_y <-total[,2]/sum(total[,2])
      X_y <- total[,3]
      total <- cbind(psi,wt,agep_glob)
      total <- na.omit(total)
    
      ####
      psi <- total[,1]
      wt <-total[,2]/sum(total[,2])
      X_p <- total[,3]
      m1 <- sum(wt*psi) 
      m2 <-sum(wt_y*y)
      
      #### For the Naive test 
      percent <-  (m2 -  m1)/ m2
      sd_y <-   sqrt(sum( wt_y*( y  - m2 )^2))
      sd_psi <-   sqrt(sum( wt*( psi  - m1 )^2))
      denom <-  sqrt( sd_psi^2/ length(psi) +  sd_y^2/ length(y))
      df1 =  denom^4/( (sd_psi^2/ length(psi))^2/(length(psi)-1) +  (sd_y^2/ length(y))^2/(length(y)-1)   )
      p_val = 2*(1 - pt(abs(m2 - m1)/denom, df1, lower.tail = TRUE, log.p = FALSE))

      #### For the variance test 
      alpha1 <-  sum(wt_y*y) /sum(wt*psi)
      psi  <- psi*alpha1
      
      zi_y = 2*y*(y-m2)
      zi_p = 2*psi*(psi-m1)
      m2_z = sum(wt_y*zi_y)
      m1_z = sum(wt*zi_p)
      
      sd_z_y <-   sqrt(sum( wt_y*( zi_y  -  m2_z )^2))
      sd_z_p <-   sqrt(sum( wt*( zi_p  - m1_z )^2))
      
      denom <-  sqrt( sd_z_p^2/ length(psi) +  sd_z_y^2/ length(y))
      p_val_var = 1 - pt((sd_y^2 - sd_psi^2)/denom, length(y)+length(psi)-2, lower.tail = TRUE, log.p = FALSE)
      #p_val_varF  = var.test(y,psi, ratio = 1,alternative = c( "greater"))$p.value
      
      psi  <- psi/alpha1
      y  <- y /alpha1

      #####
      n_y= length(y)
      n_p = length(psi)
      n_y
      n_p
      N = n_p + n_y
      level = 5/100
   
      Ttest_res <- vector("list")
      Result_list<-  vector("list")
      ResultT_list<-  vector("list")
      T_N_list<-  vector("list")
      c_star_list<- vector("list")
      
      D <- rbind(matrix(1,n_y,1),matrix(0,n_p,1))
      ww <- rbind(matrix(wt_y* (n_y/N)  ,n_y,1),matrix(wt* (n_p/N),n_p,1))
      W <-  N*((1-D)/sum((1-D)) - D / sum(D))
      X_tilde <- rbind(matrix(1,n_y,1),matrix(1,n_p,1))
      Y_tilde <- rbind(matrix(y,n_y,1),matrix(psi,n_p,1))
     
      
      ## set the parameters of the test
      set.seed(40000)
      prec=100
      tuningParam<- vector(mode="list", length=6)
      tuningParam[["p"]] <- 0.05
      tuningParam[["epsilon"]] <- 0.05
      tuningParam[["B"]] <-5000
      tuningParam[["y_grid"]] <-quantile(Y_tilde, seq(0,1,length.out=prec))
      tuningParam[["c"]] <- 0.3
      tuningParam[["kappa"]] <- 0.001
      

      ### launch the test
      res <- test(Y_tilde ,D,NULL,ww,"Mult",4,tuningParam)
      
      
      ## store the results.
      N <- res[[1]]
      cv01 <-   res[[2]]
      cv05 <-  res[[3]]
      cv10 <-  res[[4]]
      T_n<-  res[[5]]
      p_value <- res[[7]]
      T_reps <- res[[8]]
  
      Result <- !(T_n > cv05)
      Result
     
      
      res <- c(p_value,Result,n_p,n_y ,m1,m2,alpha1, m2-m1 ,p_val , percent, p_val_var) 
      data_testsW  <- rbind(data_testsW  ,res)
     
    }
    colnames(    data_testsW)<- c("p_value","Result","n_p","n_y" ,"m_psi","m_y","alpha1", "m_y - m_psi" ,"p_val naive", "percent col1", "pval variance")
    rownames(    data_testsW)<- c("All", "Women","Men","White","Minorities","Coll. deg.","No Coll. deg.","High Num.","Low Num.","Ten <= 6", "Ten > 6")


   data_testsW1 <- data_testsW[,c("percent col1", "p_val naive", "pval variance" ,"p_value","n_p","n_y" )]
  

  ##### print table 2 on screen and in latex
  out1 <- print(data_testsW1, digits=2)
  xtable(data_testsW1, digits=3)
  
  data_testsW1
  
  
  
