###################################
#  Code to replicate the combined test and direct tests results (Table 3) as well as the attrition table results  (Table S2)
###################################


rm(list=ls())
## load packages
library(RationalExp)
library(foreign)
require(pracma)
require(MESS)
require(sfsmisc)
library(ggplot2)
library(reshape2)
library(matlab)
library(snowfall)
library(survey)

path="TO COMPLETE WITH THE PATH OF THE CODES FOLDER"
source(file=paste0(path,"test_combi.R"))

## define output arrays
outt0 <- NULL
out_direct0 <-NULL
data_testsW0 <- NULL

## different levels of winsorisation 
qu_v <- c(0.2, 0.1,0.05,0.01)
# index0=1
# index=1
for( index0 in 1:length(qu_v)){
  out_direct = NULL
  data_testsW <- NULL
  ql = 0.00
  qu =0.95 # qu_v[index0]
  
    ## select the subpopulation
     for(index in c(1,4:13)){
      
       
       #######################################################################################
       ##################  load all datasets      ###############
       load( file=paste0(path,"data/sub_data_real.Rdata"))
       load( file=paste0(path,"data/sub_data_exp.Rdata"))
       load( file=paste0(path,"data/data_1_sel.Rdata"))
       load( file=paste0(path,"data/data_2_sel.Rdata"))
       load( file=paste0(path,"data/sub_data.Rdata"))
       
       
      ### all
      if(index ==1){
        ### NADA
        
      }
      
      ### self employed
      if(index ==2){
        
        indic <- data_1_sel$self==1
        data_1_sel <- data_1_sel[indic,]
      }
      ### Wage earners
      if(index ==3){
        indic <- data_1_sel$self==1
        data_1_sel <- data_1_sel[!indic,]
      }
      
      ### women
      if(index ==4){
        indic <- data_1_sel$sex==0
        data_1_sel <- data_1_sel[indic,]
      }
      ### men
      if(index ==5){
        indic <- data_1_sel$sex==0
        data_1_sel <- data_1_sel[!indic,]
      }
      ### white
      if(index ==6){
        indic <- data_1_sel$white==1
        data_1_sel <- data_1_sel[indic,]
      }  
      
      ### others
      if(index ==7){
        indic <- data_1_sel$white==1
        data_1_sel <- data_1_sel[!indic,]
      }  
      
      ### college
      if(index ==8){
        indic <- data_1_sel$HS==1
        data_1_sel <- data_1_sel[indic,]
      }  
      
      ### no coll
      if(index ==9){
        indic <- data_1_sel$HS==1
        data_1_sel <- data_1_sel[!indic,]
      }    
      
     
     
      if(index ==10){
        indic <- data_1_sel$NUM_CAT==2
        data_1_sel <- data_1_sel[indic,]
      }
      if(index ==11){
        indic <- data_1_sel$NUM_CAT==2
        data_1_sel <- data_1_sel[!indic,]
      } 
      
      
      if(index ==12){
        indic <- data_1_sel$exp<=2
        data_1_sel <- data_1_sel[indic,]
      } 
      
      if(index ==13){
        indic <- data_1_sel$exp >2
        data_1_sel <- data_1_sel[indic,]
      }
      
      indic <- data_2_sel$work==0 & data_2_sel$unemp==0  
      indic1 <- indic
      indic1[is.na(indic)] <- FALSE
      data_2_sel <- data_2_sel[!indic1,]
      
      if(index ==1){
        ### NADA
        
      }
      
      ### Wage earners
      if(index ==2){
        
        indic <- data_2_sel$self==1
        data_2_sel <- data_2_sel[indic,]
      }
      ### self employed
      if(index ==3){
        indic <- data_2_sel$self==1
        data_2_sel <- data_2_sel[!indic,]
      }
      
      ### women
      if(index ==4){
        indic <- data_2_sel$sex==0
        data_2_sel <- data_2_sel[indic,]
      }
      ### men
      if(index ==5){
        indic <- data_2_sel$sex==0
        data_2_sel <- data_2_sel[!indic,]
      }
      ### white
      if(index ==6){
        indic <- data_2_sel$white==1
        data_2_sel <- data_2_sel[indic,]
      }  
      
      ### others
      if(index ==7){
        indic <- data_2_sel$white==1
        data_2_sel <- data_2_sel[!indic,]
      }  
      
      ### college
      if(index ==8){
        indic <- data_2_sel$HS==1
        data_2_sel <- data_2_sel[indic,]
      }  
      
      ### no coll
      if(index ==9){
        indic <- data_2_sel$HS==1
        data_2_sel <- data_2_sel[!indic,]
      }    
      
      if(index ==10){
        indic <- data_2_sel$NUM_CAT==2
        data_2_sel <- data_2_sel[indic,]
      }
      if(index ==11){
        indic <- data_2_sel$NUM_CAT==2
        data_2_sel <- data_2_sel[!indic,]
      } 
      
     
      if(index ==12){
        indic <- data_2_sel$exp<=2
        data_2_sel <- data_2_sel[indic,]
      } 
      
      if(index ==13){
        indic <- data_2_sel$exp >2
        data_2_sel<- data_2_sel[indic,]
      }
      
      #######################################################################################
      ##################  winsorisation of both sample                        ###############
      
      y_set <- data_1_sel
      sel <- data_1_sel$oo2e2 <quantile(data_1_sel$oo2e2, qu) & data_1_sel$oo2e2 >quantile(data_1_sel$oo2e2, ql)
      y_set <- y_set[sel ,]
      Qu = quantile( y_set$oo2e2, 1)
      Ql = quantile( y_set$oo2e2, 0)
      y_set_0 <- data_1_sel
      y_set_0[data_1_sel$oo2e2 >=quantile(data_1_sel$oo2e2, qu)  ,"oo2e2"] <-  Qu
      data_1_sel<- y_set_0
      
      
      
      y_set <- data_2_sel
      sel <- data_2_sel$past_inc <quantile(data_2_sel$past_inc, qu) & data_2_sel$past_inc >quantile(data_2_sel$past_inc, ql)
      y_set <- y_set[sel ,]
      Ql = quantile( y_set$past_inc , 0)
      Qu = quantile( y_set$past_inc , 1)
      y_set_0 <- data_2_sel
      y_set_0[data_2_sel$past_inc >=quantile(data_2_sel$past_inc, qu)  ,"past_inc"] <-  Qu
      data_2_sel<- y_set_0
      
      #######################################################################################
      ##################  Subsample of merged realized and expected earnings  ###############
      
      sub_data_exp <- data_1_sel
      sub_data_real <-data_2_sel
      date_exp<- sort(unique(sub_data_exp$date))
      
      merged_0 <- subset(sub_data_exp, date==date_exp[1])
      merged_1 <- subset(sub_data_real, date==date_exp[1]+4)
      merged <- merge(merged_1,merged_0, by="userid")
      merged_0 <- subset(sub_data_exp, date==date_exp[2])
      merged_1 <- subset(sub_data_real, date==date_exp[2]+4)
      merged <- rbind(merged ,merge(merged_1,merged_0, by="userid"))
      merged_0 <- subset(sub_data_exp, date==date_exp[3])
      merged_1 <- subset(sub_data_real, date==201603)
      merged <- rbind(merged ,merge(merged_1,merged_0, by="userid"))
      merged2 <- merged
      merged <- merge(subset(data_1_sel,date==date_exp[1]),subset(data_2_sel,date==date_exp[1]+4),by="userid",  all.x = TRUE)
      merged <- rbind(merged ,merge(subset(data_1_sel,date==date_exp[2]),subset(data_2_sel,date==date_exp[2]+4),by="userid",  all.x = TRUE))
      merged2 <- merged
      merged2$D <- (!is.na(merged2$past_inc))*1
      merged2$NUM_CAT.x <- merged2$NUM_CAT.x-2
      merged2$white<- (merged2$black.x==0)*1
      merged2$exp_l<- (merged2$exp.x>2)*1
      merged2$D0  <- ! merged2$D
      
      
      if(index0==1 & index==1){
        ###### for attrition in table S2
        merged2$date <- merged2$date.x-201502
        # attri0 <- glm(formula =D0 ~oo2e2  + sex.x + white + HS.x + NUM_CAT.x+ exp_l +date ,data =merged2, family = binomial)
        # summary(attri0)
        
        attri1  <- svyglm(formula =D0 ~oo2e2  + sex.x + white + HS.x + NUM_CAT.x+ exp_l +date, design=svydesign(ids=~1, weights=~weight.x, data=merged2), family=binomial)
        summary(attri1)
      }
      
      
      estim_rat_B <- function(x,bootdat,wt){
        rho <- x[1]
        res <- sum(wt*(bootdat[,"past_inc"] -rho*bootdat[,"oo2e2"])^2)
         return(res)
      }
      reps=10
      
      
      clusbootreg <- function(data, cluster, value, reps=10,wt0, lower=0, upper=100){
        ##compute the weigthed regression value
        if(length(value)==1){
          reg1 <- optim(value,estim_rat_B,method="Brent" , upper=4, lower=0,bootdat  = data, wt=wt0/sum(wt0))$par
        }else{
          reg1 <- optim(value,estim_rat_B, bootdat  = data, wt=wt0/sum(wt0))$par  
        }
        
        wt1 <- wt0[!duplicated(cluster)]
        wt1 <- wt1/sum(wt1)
        # identify the clusters
        clusters <- names(table(cluster))
        sterrs <- matrix(NA, nrow=reps, ncol=length(reg1))
        dim(sterrs)
        for(i in 1:reps){
          index <- sample(1:length(clusters), length(clusters), replace=TRUE, prob= wt1)
          aa <- clusters[index]
          bb <- table(aa)
          bootdat <- NULL
          for(j in 1:max(bb)){
            cc <- data[cluster %in% names(bb[bb %in% j]),]
            for(k in 1:j){
              bootdat <- rbind(bootdat, cc)
            }
          }
          if(length(value)==1){
            sterrs[i,] <- optim(value,estim_rat_B,method="Brent", upper=4, lower=0.1, bootdat=bootdat, wt=as.numeric(matrix(1/dim(bootdat)[1],1,dim(bootdat)[1])))$par
          }else{
             sterrs[i,] <- optim(value,estim_rat_B,bootdat=bootdat, wt=as.numeric(matrix(1/dim(bootdat)[1],1,dim(bootdat)[1])))$par  
          }
        }
        
        sds <- apply(sterrs,2,sd)
        
        pval <- NULL
        for(j in 1:length(reg1)){
          P_val1 <-mean( abs(sterrs[,j] - mean(sterrs[,j]) )> abs( reg1[j] - value[j]))
          pval <-c( pval , P_val1)
        }
        val <- cbind(reg1,apply(sterrs,2,sd),pval)
        
        colnames(val) <- c("Estimate","Std. Error","P.value")
        return(val)
      }
      
      merged3 <- merged2[!is.na(merged2$past_inc),]
      merged3$past_inc <- merged3$past_inc / sum(merged3$past_inc*merged3$weight.x/sum(merged3$weight.x)) *sum(merged3$oo2e2*merged3$weight.x/sum(merged3$weight.x))
      value <- c(1)
      val1 <- clusbootreg ( merged3,merged3$userid,value,reps=1000,merged3$weight.x )
      outt <- c(val1,dim(merged3)   )
      out_direct <- rbind(out_direct, outt)
      
      ##################################################################################################################################### 
      ############     Complete test. 
      ############################################################################
      data_st <- data_2_sel 
      data_psi <-data_1_sel 
      
      colnames(data_st)[3] <- "y"
      colnames(data_psi)[3] <- "psi"
      colnames(data_st)[5] <- "wt"
      colnames(data_psi)[4] <- "wt"
      data_st$X <- data_st$age
      data_psi$X <- data_psi$age
      ref <- quantile(data_st$X, seq(1,100,10)/100)
      ref<-c(0,ref,Inf)
      dates_2 <- sort(unique(data_st$date))
      dates <-sort(unique(data_psi$date))
      ############################################################################################################"
      breaks_age <- c(0,30,45,60,100)
      LIM = 2

      data_testsW_save <- NULL
      sel_age =0
    
      # for (sel_age in  sel_age_list  ){
      wy_glob <- NULL
      n_glob <- NULL
      n_glob_y <- NULL
      wp_glob <-NULL
      psi_glob <- NULL 
      y_glob <- NULL
      age_glob <- NULL
      agep_glob <- NULL
      other_y_glob <- NULL
      other_p_glob <- NULL
    
      for(i in 1:LIM){
        
        sub_1 <- subset(data_st, date==dates_2[which.min(abs(dates_2-dates[i]))+1])
        y <- sub_1$y 
        wt_y<- sub_1$wt/sum(sub_1$wt)
        other_y <- sub_1[,c("userid","date","y","wt")]
        age <- sub_1$age
       
        
        sub_2 <- subset(data_psi, date==dates[i])
        psi <- sub_2$psi
        wt<- sub_2$wt
        agep <- sub_2$age
        other_p <- sub_2[,c("userid","date","psi","wt")]
        
        psi_glob <-  c(psi_glob ,psi)
        wy_glob <-c(wy_glob,wt_y)
        wp_glob <-c(wp_glob,wt)
        y_glob <-c(y_glob,y)
        n_glob <- c( n_glob, length(psi))
        n_glob_y <- c( n_glob_y, length(y))
        age_glob <-c( age_glob,age)
        agep_glob <-c(agep_glob,agep)
        other_y_glob <- rbind(other_y_glob, other_y)
        other_p_glob <- rbind(other_p_glob, other_p)
      }
      
      y <- y_glob
      psi <- psi_glob
      
      #### managing weights
      factor<- NULL
      factor_y <- NULL
      proportions <- n_glob/length( psi_glob)
      proportions_y <- n_glob_y/length( y_glob)
      for (j in 1:LIM){
        factor <- c(factor, matrix(proportions[j],1,n_glob[j]))
        factor_y <- c(factor_y, matrix(proportions_y[j],1,n_glob_y[j]))
      }
      wt_y <-wy_glob*factor_y
      wt <-wp_glob* factor 
      
  
      total <- cbind(y,wt_y, age_glob)
      total <- na.omit(total)
      ### with taxes
      y <- total[,1]
      wt_y <-total[,2]/sum(total[,2])
      X_y <- total[,3]
      total <- cbind(psi,wt,agep_glob)
      total <- na.omit(total)
      
      psi <- total[,1]
      wt <-total[,2]/sum(total[,2])
      X_p <- total[,3]
      m1 <- sum(wt*psi) 
      m2 <-sum(wt_y*y)
      
      percent <-  (m2 -  m1)/ m2
      sd_y <-   sqrt(sum( wt_y*( y  - m2 )^2))
      sd_psi <-   sqrt(sum( wt*( psi  - m1 )^2))
      denom <-  sqrt( sd_psi^2/ length(psi) +  sd_y^2/ length(y))
      df1 =  denom^4/( (sd_psi^2/ length(psi))^2/(length(psi)-1) +  (sd_y^2/ length(y))^2/(length(y)-1)   )
      p_val = 2*(1 - pt(abs(m2 - m1)/denom, df1, lower.tail = TRUE, log.p = FALSE))
      p_val1 = 2*(1 - pt(abs(m2 - m1)/denom, length(y)+length(psi)-2, lower.tail = TRUE, log.p = FALSE))

      alpha1 <-  sum(wt_y*y) /sum(wt*psi)
      y  <- y /alpha1
      
    
      #psi <- psi
      n_y= length(y)
      n_p = length(psi)
      n_y
      n_p
      N = n_p + n_y
      
      other_p <- cbind(other_p_glob, psi,wt )
      other_y <- cbind(other_y_glob, y, wt_y)
      
      ######################
      p=0.6
      level = 5/100
      
      Ttest_res <- vector("list")
      Result_list<-  vector("list")
      ResultT_list<-  vector("list")
      T_N_list<-  vector("list")
      c_star_list<- vector("list")
      
      D <- rbind(matrix(1,n_y,1),matrix(0,n_p,1))
      ww <- rbind(matrix(wt_y* (n_y/N)  ,n_y,1),matrix(wt* (n_p/N),n_p,1))
      W <-  N*((1-D)/sum((1-D)) - D / sum(D))
      colnames(other_y) <- c("userid","date","value_1", "wt_1", "value_2" ,"wt_2")
      colnames(other_p) <- c("userid","date","value_1", "wt_1", "value_2" ,"wt_2")
      other = rbind(  other_y,  other_p)
      other$D <- D
      other$ww <- ww
      X_tilde <- rbind(matrix(1,n_y,1),matrix(1,n_p,1))
      Y_tilde <- rbind(matrix(y,n_y,1),matrix(psi,n_p,1))
    
      
      #### set the parameters for the test
      set.seed(40000)
      prec=100
      tuningParam<- vector(mode="list", length=6)
      tuningParam[["p"]] <- 0.05
      tuningParam[["epsilon"]] <- 0.05
      tuningParam[["B"]] <-5000
      tuningParam[["y_grid"]] <-quantile(Y_tilde, seq(0,1,length.out=prec))
      tuningParam[["c"]] <- 0.3
      tuningParam[["kappa"]] <- 0.001
      qq=0.2
  
      
      ### launch the test
      res <- test_combi(Y_tilde ,D,NULL,ww,"Mult",4,tuningParam,data=other, merged3 = merged3,cluster=merged3$userid,wt0=merged3$weight.x , lambda_bar = qu_v[index0],  qq= qq)
      
      
      
      ## store the results
      N <- res[[1]]
      cv01 <-   res[[2]]
      cv05 <-  res[[3]]
      cv10 <-  res[[4]]
      T_n<-  res[[5]]
      p_value <- res[[7]]
      T_reps <- res[[8]]
      T_n0 <- res[[9]] 
      T_reps0 <- res[[10]]
      p_value0 <- res[[11]] 
      Result <- !(T_n > cv05)
      Result
     
      res <- c(p_value,Result,n_p,n_y,m1,m2,alpha1, m2-m1 ) 
      data_testsW  <- rbind(data_testsW  ,res)
     }
    colnames(    data_testsW)<- c("p_value","Result","n_p","n_y","m_psi","m_y","alpha1", "m_y - m_psi" )
    rownames(    data_testsW)<- c("All", "Women","Men","White","Minorities","Coll. deg.","No Coll. deg.","High Num.","Low Num.","Ten <= 6", "Ten > 6")
    data_testsW0 <- rbind( data_testsW0,  data_testsW )
    outt0 <-rbind(outt0, outt)
    out_direct0 <-rbind(out_direct0,out_direct)
  }
  
  
  #### to print table 3 (developed form with respect to the two columns of the Combined test)
  data_testsW1 <- cbind(out_direct[,c(1,3)],data_testsW[,c("p_value","n_p","n_y" )],out_direct[,4] )
  out1 <- print(data_testsW1, digits=2)
  
  library(xtable)
  xtable(  data_testsW1, digits=3)
  
  data_testsW1
  
  
  #### to print table S2 (attrition)
  summary(attri1)
  
  
