###################################
#  Code to replicate the descriptive statistics, Table 1
###################################

rm(list=ls())

## load packages
library(foreign)
require(pracma)
require(MESS)
require(sfsmisc)
library(ggplot2)
library(reshape2)
library(matlab)
library(Hmisc)

path="TO COMPLETE WITH THE PATH OF THE CODES FOLDER"

load( file=paste0(path,"data/sub_data_real.Rdata"))
load( file=paste0(path,"data/sub_data_exp.Rdata"))
load( file=paste0(path,"data/data_1_sel.Rdata"))
load( file=paste0(path,"data/data_2_sel.Rdata"))
load( file=paste0(path,"data/sub_data.Rdata"))

#### winsorisation of expectations and earnings
ql = 0.00
qu = 0.95

y_set <- data_1_sel
sel <- data_1_sel$oo2e2 <quantile(data_1_sel$oo2e2, qu) & data_1_sel$oo2e2 >quantile(data_1_sel$oo2e2, ql)
y_set <- y_set[sel ,]
Qu = quantile( y_set$oo2e2, 1)
Ql = quantile( y_set$oo2e2, 0)
y_set_0 <- data_1_sel
y_set_0[data_1_sel$oo2e2 >=quantile(data_1_sel$oo2e2, qu)  ,"oo2e2"] <-  Qu
data_1_sel<- y_set_0

y_set <- data_2_sel
sel <- data_2_sel$past_inc <quantile(data_2_sel$past_inc, qu) & data_2_sel$past_inc >quantile(data_2_sel$past_inc, ql)
y_set <- y_set[sel ,]
Ql = quantile( y_set$past_inc , 0)
Qu = quantile( y_set$past_inc , 1)
y_set_0 <- data_2_sel
y_set_0[data_2_sel$past_inc >=quantile(data_2_sel$past_inc, qu)  ,"past_inc"] <-  Qu
data_2_sel<- y_set_0

############################ managing survey weigths
data_st <- data_2_sel 
data_psi <-data_1_sel 

colnames(data_st)[3] <- "y"
colnames(data_psi)[3] <- "psi"
colnames(data_st)[5] <- "wt"
colnames(data_psi)[4] <- "wt"
data_st$X <- data_st$age
data_psi$X <- data_psi$age

dates_2 <- sort(unique(data_st$date))
dates <-sort(unique(data_psi$date))

LIM = 2
sel_age =0
R2_s =NULL
wy_glob <- NULL
n_glob <- NULL
n_glob_y <- NULL
wp_glob <-NULL
psi_glob <- NULL 
y_glob <- NULL
age_glob <- NULL
agep_glob <- NULL


for(i in 1:LIM){
  
  sub_1 <- subset(data_st, date==dates_2[which.min(abs(dates_2-dates[i]))+1])
  y <- sub_1$y 
  wt_y<- sub_1$wt/sum(sub_1$wt)
  age <- sub_1$age
   
  
  sub_2 <- subset(data_psi, date==dates[i])
  psi <- sub_2$psi
  wt<- sub_2$wt
  agep <- sub_2$age
  
  
  psi_glob <-  c(psi_glob ,psi)
  wy_glob <-c(wy_glob,wt_y)
  wp_glob <-c(wp_glob,wt)
  y_glob <-c(y_glob,y)
  n_glob <- c( n_glob, length(psi))
  n_glob_y <- c( n_glob_y, length(y))
  age_glob <-c( age_glob,age)
  agep_glob <-c(agep_glob,agep)
}

y <- y_glob
psi <- psi_glob

#### managing survey weights
factor<- NULL
factor_y <- NULL
proportions <- n_glob/length( psi_glob)
proportions_y <- n_glob_y/length( y_glob)
for (j in 1:LIM){
  factor <- c(factor, matrix(proportions[j],1,n_glob[j]))
  factor_y <- c(factor_y, matrix(proportions_y[j],1,n_glob_y[j]))
}

wt_y <-wy_glob*factor_y
wt <-wp_glob* factor 
data_1_sel$psi <- data_1_sel$oo2e2
data_2_sel$y <- data_2_sel$past_inc
wt1_sel <- data_1_sel$weight/sum( data_1_sel$weight)
wt2_sel <- data_2_sel$weight/sum( data_2_sel$weight)


wt1_sel2 <- rep(1/length (data_1_sel$weight),length (data_1_sel$weight)) 
wt2_sel2 <-rep(1/length (data_2_sel$weight),length (data_2_sel$weight)) 
weighted.var <- function(x, w, na.rm = FALSE) {
  if (na.rm) {
    w <- w[i <- !is.na(x)]
    x <- x[i]
  }
  sum.w <- sum(w)
  sum.w2 <- sum(w^2)
  mean.w <- sum(x * w) / sum(w)
  (sum.w / (sum.w^2 - sum.w2)) * sum(w * (x - mean.w)^2, na.rm =
                                       na.rm)
}


##########################################################################################################

options(digits=3)
res <- NULL 
row1 <- cbind("Male", round( sum(data_1_sel$sex*wt1_sel),  digits = 2),  round(sqrt(weighted.var(data_1_sel$sex, wt1_sel)),  digits = 2))
res <- rbind(res,row1)
row1 <- cbind("White0", round(sum(data_1_sel$white*wt1_sel) ,  digits = 2), round( sqrt(weighted.var(data_1_sel$white,wt1_sel)),  digits = 2))
res <- rbind(res,row1)
row1 <- cbind("Percent Coll",round(sum((data_1_sel$HS==0)*wt1_sel),  digits = 2), round( sqrt(weighted.var(data_1_sel$HS==0,wt1_sel)),  digits = 2)  )
res <- rbind(res,row1)
row1 <- cbind("Percent Low num ", round(sum((data_1_sel$NUM_CAT!=2)*wt1_sel),  digits = 2),  round(sqrt(weighted.var((data_1_sel$NUM_CAT!=2),wt1_sel)),  digits = 2))   
res <- rbind(res,row1)
row1 <- cbind("Percent less 6 month ",round(sum((data_1_sel$exp<=2)*wt1_sel),  digits = 2),  round(sqrt(weighted.var((data_1_sel$exp<=2),wt1_sel)),  digits = 2))   
res <- rbind(res,row1)
row1 <- cbind("Mean age",round(sum((data_1_sel$age)*wt1_sel),  digits = 1),  round(sqrt(weighted.var((data_1_sel$age),wt1_sel)),  digits = 1))   
res <- rbind(res,row1)
row1 <- cbind("Mean psi",round(weighted.mean(psi,wt),  digits = 0),  round(sqrt(weighted.var(psi,wt)),  digits = 0))   
res <- rbind(res,row1)
row1 <- cbind("Mean Y",round(sum(y*wt_y),  digits = 0),  round(sqrt(weighted.var(y,wt_y)),  digits = 0))   
res <- rbind(res,row1)

colnames(res)[2] <- "Mean"
colnames(res)[3] <- "Std. dev."
res <- as.data.frame(res)

res

library(xtable)
xtable(res)
