test_combi <- function (Y_tilde, D, X = matrix(1, length(Y_tilde), 1), 
                        weights = rep(1/length(Y_tilde), 
                    length(Y_tilde)), generalized = "No", nbCores = 1, 
          tuningParam = NULL, data =  other, merged3 = merged3,cluster=merged3$userid,wt0=merged3$weight.x, lambda_bar = 0.05, qq=0.5)
{
  n_y = sum(D)
  if (is.null(X)) {
    X = matrix(1, length(Y_tilde), 1)
  }
  if (is.null(weights)) {
    weights = as.matrix(rep(1/length(Y_tilde), length(Y_tilde)))
  }
  if (is.null(generalized)) {
    generalized = "No"
  }
  if (is.null(nbCores)) {
    nbCores = 1
  }
  if (is.null(tuningParam)) {
    p = 0.05
    epsilon = 0.05
    B = 500
    prec = 30
    y_grid = quantile(Y_tilde, seq(0, 1, length.out = prec))
    c = 0.3
    kappa = 0.001
  }else {
    p = tuningParam[["p"]]
    epsilon = tuningParam[["epsilon"]]
    B = tuningParam[["B"]]
    y_grid = tuningParam[["y_grid"]]
    c = tuningParam[["c"]]
    kappa = tuningParam[["kappa"]]
  }
  prec = length(y_grid)
  out <- vector("list")
  N = length(Y_tilde)
  Sigma0 = var(X)
  if (max(Sigma0) == 0) {
    N3 = 1
  }else {
    N3 = min(N, 50)
  }
  if (generalized == "Add" | generalized == "Mult") {
    yy <- Y_tilde[D == 1]
    ypsi <- Y_tilde[D == 0]
    if (generalized == "Add") {
      p = 0
      alpha <- sum(yy * weights[D == 1]/sum(weights[D == 
                                                      1])) - sum(ypsi * weights[D == 0]/sum(weights[D == 
                                                                                                      0]))
      Y_tilde[D == 1] <- Y_tilde[D == 1] - alpha
    }
    if (generalized == "Mult") {
      p = 0
      alpha <- sum(yy * weights[D == 1]/sum(weights[D == 
                                                      1]))/sum(ypsi * weights[D == 0]/sum(weights[D == 
                                                                                                    0]))
      Y_tilde[D == 1] <- Y_tilde[D == 1]/alpha
    }
  }
  DX = dim(X)[2]
  kappa_n = sqrt(kappa * log(N))
  B_n = sqrt(c * log(N)/log(log(N)))
  W <- ((1 - D)/sum((1 - D)) - D/sum(D)) * N
  phi_n <- NULL
  M_bar <- NULL
  T_n_grid <- matrix(0, prec, 1)
  for (i in 1:prec) {
    y <- y_grid[i]
    eq_1 <- W * Y_tilde
    ineq_1 <- -W * (y - Y_tilde) * (Y_tilde <= y)
    data_test <- cbind(ineq_1, eq_1)
    ## part of the stat on marginals
    res <- test_base(Y_tilde, X, D, data_test, epsilon, B, 
                     N3, c, kappa, p, N, weights)
  
    T_n_grid[i, 1] <- res[[1]] 
    phi_n <- cbind(phi_n, res[[2]])
    M_bar <- cbind(M_bar, res[[3]])
  }
  
  ############### part of of the stat on joint.
  estim_rat_B <- function(x,bootdat,wt){
    rho <- x[1]
    res <- sum(wt*(bootdat[,"past_inc"] -rho*bootdat[,"oo2e2"])^2)
    return(res)
  }
  
  wt0 = merged3$weight.x/sum(merged3$weight.x)
  reg10 <- optim(1,estim_rat_B,method="Brent" , upper=4, lower=0,bootdat  = merged3, wt=wt0 )
  reg1_t <- reg10$par
  # lambda_bar=0.01
  b_bar =1- 1/(1+1/lambda_bar)
  residualls = sum(wt0 *(merged3[,"past_inc"] -reg1_t*merged3[,"oo2e2"])^2)
  s0 =  residualls/var(merged3$oo2e2)/(dim( merged3)[1]-1)
  T_2 =   (max(b_bar -reg1_t, 0)/sqrt(s0))^2
  
  
  T_n0 <-   max(T_n_grid)
  T_n <-(1-qq)* max(T_n_grid)+ T_2*qq
  b_num = B
  ##
  T_reps = matrix(0, prec, B)
  
 
  ## 
  sample_mat <- matrix(0, b_num, N)
  for (k in 1:b_num) {
    sample_mat[k, ] <- sample(1:N, N, replace = TRUE, prob = weights/sum(weights))
   }
  
  T_reps2 = matrix(0, 1, B)
  if (nbCores == 1) {
    for (b_rep in 1:b_num) {
      T_reps2[1, b_rep] <- boot_stat(b_rep, Y_tilde, X, 
                                     D, epsilon, N3, p, prec, N, sample_mat, generalized, 
                                     weights, y_grid, phi_n, M_bar, DX)
    }
  }else {
    sfInit(parallel = TRUE, cpus = nbCores, type = "SOCK")
    sfExportAll()
    T_reps2 <- sfLapply(1:B, boot_stat, Y_tilde, X, D, epsilon, 
                        N3, p, prec, N, sample_mat, generalized, weights, 
                        y_grid, phi_n, M_bar, DX)
    sfStop()
    T_reps2 <- unlist(T_reps2)
  }
  
  
  ############### part of of the stat on joint.
  # estim_rat_B0 <- function(x,bootdat,wt){
  #   rho <- x[1]
  #   res <- sum(wt*(bootdat[,"past_inc"] -rho*bootdat[,"oo2e2"])^2)
  #   return(res)
  # }
  
  ########## for the joint
  T_2 = matrix(0, 1, B)
  # b_rep=5
  ###
  wt1 <- wt0[!duplicated(cluster)]
  wt1 <- wt1/sum(wt1)
  # identify the clusters
  clusters <- names(table(cluster))
  sterrs <- matrix(NA, nrow=reps, ncol=length(reg1_t))
  
  for (b_rep in 1:b_num) {
    
    b_sample = sample_mat[b_rep,]
    data_s <- data[  b_sample, ]
    clusters_rep <- names(table(data_s$userid))
    # length(clusters_rep)
    
    # index <- sample(1:length(clusters), length(clusters), replace=TRUE, prob= wt1)
    index <- sample(1:length(clusters_rep), length(clusters_rep), replace=TRUE)
    aa <- clusters_rep[index]
    bb <- table(aa)
    bootdat <- NULL
    for(j in 1:max(bb)){
      cc <- merged3[clusters_rep %in% names(bb[bb %in% j]),]
      for(k in 1:j){
        bootdat <- rbind(bootdat, cc)
      }
    }
    bootdat  <- na.omit(bootdat )
    xxx =  sample(1:dim(bootdat)[1], min(dim(bootdat)[1], length(clusters)), replace=FALSE)
    bootdat <-bootdat[  xxx, ]
    # xxx =  sample(1:dim(bootdat)[1], min(dim(bootdat)[1], length(clusters)), replace=FALSE)
    # bootdat <-bootdat[  xxx, ]
    # dim(merged4)
    # dim(bootdat)
    
    # index <- sample(1:length(clusters), length(clusters), replace=TRUE, prob= wt1)
    # aa <- clusters[index]
    # bb <- table(aa)
    # bootdat <- NULL
    # for(j in 1:max(bb)){
    #   cc <- merged3[cluster %in% names(bb[bb %in% j]),]
    #   for(k in 1:j){
    #     bootdat <- rbind(bootdat, cc)
    #   }
    # }

    # 
    # sub_data_exp <- data_s[data_s$D==0,]
    # sub_data_real <-data_s[data_s$D==1,]
    # colnames(sub_data_exp) <- c("userid","date","oo2e2", "wt_1", "value_2" ,"wt_2")
    # colnames(sub_data_real) <- c("userid","date","past_inc", "wt_10", "value_2" ,"wt_2")
    # date_exp<- sort(unique(sub_data_exp$date))
    # merged_0 <- subset(sub_data_exp, date==date_exp[1])
    # merged_1 <- subset(sub_data_real, date==date_exp[1]+4)
    # merged <- merge(merged_1,merged_0, by="userid")
    # merged_0 <- subset(sub_data_exp, date==date_exp[2])
    # merged_1 <- subset(sub_data_real, date==date_exp[2]+4)
    # merged <- rbind(merged ,merge(merged_1,merged_0, by="userid"))
    # merged_0 <- subset(sub_data_exp, date==date_exp[3])
    # merged_1 <- subset(sub_data_real, date==201603)
    # merged <- rbind(merged ,merge(merged_1,merged_0, by="userid"))
    # merged <- merge(subset( sub_data_exp,date==date_exp[1]),subset(sub_data_real,date==date_exp[1]+4),by="userid",  all.x = TRUE)
    # merged <- rbind(merged ,merge(subset( sub_data_exp,date==date_exp[2]),subset(sub_data_real,date==date_exp[2]+4),by="userid",  all.x = TRUE))
    # merged2 <- merged
    # merged2$D <- (!is.na(merged2$past_inc))*1
    # merged4 <- merged2[!is.na(merged2$past_inc),]
    # merged4$past_inc <- merged4$past_inc / sum(merged4$past_inc*merged4$wt_1/sum(merged4$wt_1)) *sum(merged4$oo2e2*merged4$wt_1/sum(merged4$wt_1))
    # # merged4 <- merged3[!duplicated(merged3),]
    # # merged4 <- merged4[!duplicated(merged4),]
    # xxx =  sample(1:dim(merged4)[1], min(dim(merged4)[1],dim(merged3)[1]), replace=FALSE)
    # merged4 <- merged4[  xxx, ]
    # dim(merged4)
    
    merged4 <- bootdat
    ## sterrs[i,] <- optim(value,estim_rat_B,method="Brent", upper=4, lower=0.1, bootdat=bootdat, wt=as.numeric(matrix(1/dim(bootdat)[1],1,dim(bootdat)[1])))$par
    wt00=as.numeric(matrix(1/dim( merged4)[1],1,dim( merged4)[1]))
    reg10 <- optim(1,estim_rat_B,method="Brent" , upper=4, lower=0,bootdat  = merged4,  wt=wt00)
    reg1 <- reg10$par
    # lambda_bar=0.01
    b_bar =1- 1/(1+1/lambda_bar)
    residuals = sum(  wt00*(merged4[,"past_inc"] -reg1*merged4[,"oo2e2"])^2)
    s0 =  sqrt(residuals/var(merged4$oo2e2)/(dim( merged4)[1]-1))
    # T_20 =   (sqrt(dim(merged4)[1])*max( b_bar -reg1 , 0)/sqrt(s0))^2
    
    # sum(  wt00*(merged4[,"past_inc"]*merged4[,"oo2e2"]))/sum(  wt00*merged4[,"oo2e2"]^2)
    T_2[1, b_rep] <-    (max( reg1_t - reg1  , 0)/s0)^2
  }
  # # quantile( T_reps2 )
  # quantile( T_2)
  T_reps0 <- T_reps2
  # T_reps2 <-   T_reps0
  T_reps2 <- T_reps2*(1-qq)+ T_2*qq

# T_reps0[1:100]

  T_reps = sort(T_reps2)
  p_index = 0
  for (p_rep in 1:B) {
    if (T_reps[p_rep] < T_n) {
      p_index = p_index + 1
    }
  }
  if (p_index == 0) {
    p_index = 1
  }
  p_value = 1 - (p_index - 1)/(B - 1)
  
  
  ##############
  T_reps0 = sort(T_reps0)
  p_index = 0
  for (p_rep in 1:B) {
    if (T_reps0[p_rep] < T_n0) {
      p_index = p_index + 1
    }
  }
  if (p_index == 0) {
    p_index = 1
  }
  p_value0 = 1 - (p_index - 1)/(B - 1)
  
  cv01 = quantile(T_reps, 0.99, na.rm = TRUE)
  cv05 = quantile(T_reps, 0.95, na.rm = TRUE)
  cv10 = quantile(T_reps, 0.9, na.rm = TRUE)
  out[[1]] <- N
  out[[2]] <- cv01
  out[[3]] <- cv05
  out[[4]] <- cv10
  out[[5]] <- T_n
  out[[6]] <- B
  out[[7]] <- p_value
  out[[8]] <- T_reps
  out[[9]] <- T_n0
  out[[10]] <- T_reps0
  out[[11]] <- p_value0
  
  cat("Conditional Moment Inequalities Test   Number of obs : ", 
      N, "\nTest Statistic : ", T_n, "\n ")
  cat("Critical Value (1%) ", cv01, "\n")
  cat("Critical Value (5%) ", cv05, "\n")
  cat("Critical Value (10%) ", cv10, "\n")
  cat("p-value  : ", p_value)
  return(out)
}